diff -r e32ff462bf6e trytond/modules/account_invoice/invoice.py
--- a/trytond/modules/account_invoice/invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -13,6 +13,13 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 from trytond.config import CONFIG
+from trytond.rpc import RPC
+
+__all__ = ['Invoice', 'InvoicePaymentLine', 'InvoiceLine',
+    'InvoiceLineTax', 'InvoiceTax',
+    'PrintInvoiceWarning', 'PrintInvoice', 'InvoiceReport',
+    'PayInvoiceStart', 'PayInvoiceAsk', 'PayInvoice',
+    'CreditInvoiceStart', 'CreditInvoice']
 
 _STATES = {
     'readonly': Eval('state') != 'draft',
@@ -38,8 +45,7 @@
 
 class Invoice(Workflow, ModelSQL, ModelView):
     'Invoice'
-    _name = 'account.invoice'
-    _description = __doc__
+    __name__ = 'account.invoice'
     _order_name = 'number'
     company = fields.Many2One('company.company', 'Company', required=True,
         states=_STATES, select=True, domain=[
@@ -79,7 +85,7 @@
         required=True, states=_STATES, depends=_DEPENDS,
         on_change=['party', 'payment_term', 'type', 'company'])
     party_lang = fields.Function(fields.Char('Party Language',
-        on_change_with=['party']), 'get_party_language')
+        on_change_with=['party']), 'on_change_with_party_lang')
     invoice_address = fields.Many2One('party.address', 'Invoice Address',
         required=True, states=_STATES, depends=['state', 'party'],
         domain=[('party', '=', Eval('party'))])
@@ -89,9 +95,9 @@
                 | (Eval('lines') & Eval('currency'))),
             }, depends=['state', 'lines'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['currency']), 'get_currency_digits')
+        on_change_with=['currency']), 'on_change_with_currency_digits')
     currency_date = fields.Function(fields.Date('Currency Date',
-        on_change_with=['invoice_date']), 'get_currency_date',)
+        on_change_with=['invoice_date']), 'on_change_with_currency_date',)
     journal = fields.Many2One('account.journal', 'Journal', required=True,
         states=_STATES, depends=_DEPENDS, domain=[('centralised', '=', False)])
     move = fields.Many2One('account.move', 'Move', readonly=True)
@@ -138,17 +144,18 @@
     invoice_report_cache = fields.Binary('Invoice Report', readonly=True)
     invoice_report_format = fields.Char('Invoice Report Format', readonly=True)
 
-    def __init__(self):
-        super(Invoice, self).__init__()
-        self._check_modify_exclude = ['state', 'payment_lines',
+    @classmethod
+    def __setup__(cls):
+        super(Invoice, cls).__setup__()
+        cls._check_modify_exclude = ['state', 'payment_lines',
                 'invoice_report_cache', 'invoice_report_format']
-        self._constraints += [
+        cls._constraints += [
             ('check_account', 'account_different_company'),
             ('check_account2', 'same_account_on_line'),
         ]
-        self._order.insert(0, ('number', 'DESC'))
-        self._order.insert(1, ('id', 'DESC'))
-        self._error_messages.update({
+        cls._order.insert(0, ('number', 'DESC'))
+        cls._order.insert(1, ('id', 'DESC'))
+        cls._error_messages.update({
             'reset_draft': 'You can not reset to draft ' \
                     'an invoice that has move!',
             'missing_tax_line': 'Taxes defined ' \
@@ -178,7 +185,7 @@
                     'as on invoice line!',
             'delete_cancel': 'Invoice "%s" must be cancelled before deletion!',
             })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'proforma'),
                 ('proforma', 'open'),
                 ('draft', 'open'),
@@ -189,7 +196,7 @@
                 ('proforma', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': ~Eval('state').in_(['draft', 'proforma']),
                     },
@@ -211,10 +218,11 @@
                     },
                 })
 
-    def init(self, module_name):
-        super(Invoice, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(Invoice, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.2 invoice_date is no more required
         table.not_null_action('invoice_date', action='remove')
@@ -226,18 +234,18 @@
                 and table.column_exist('invoice_report_cache')):
             limit = cursor.IN_MAX
             cursor.execute('SELECT COUNT(id) '
-                'FROM "' + self._table + '"')
+                'FROM "' + cls._table + '"')
             invoice_count, = cursor.fetchone()
             for offset in range(0, invoice_count, limit):
                 cursor.execute(cursor.limit_clause(
                     'SELECT id, invoice_report '
-                    'FROM "' + self._table + '"'
+                    'FROM "' + cls._table + '"'
                     'ORDER BY id',
                     limit, offset))
                 for invoice_id, report in cursor.fetchall():
                     if report:
                         report = buffer(base64.decodestring(str(report)))
-                        cursor.execute('UPDATE "' + self._table + '" '
+                        cursor.execute('UPDATE "' + cls._table + '" '
                             'SET invoice_report_cache = %s '
                             'WHERE id = %s', (report, invoice_id))
             table.drop_column('invoice_report')
@@ -245,283 +253,231 @@
         # Add index on create_date
         table.index_action('create_date', action='add')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return Transaction().context.get('type', 'out_invoice')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_currency(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.id
 
-    def default_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency_digits():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.digits
         return 2
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_payment_term(self):
-        payment_term_obj = Pool().get('account.invoice.payment_term')
-        payment_term_ids = payment_term_obj.search(self.payment_term.domain)
-        if len(payment_term_ids) == 1:
-            return payment_term_ids[0]
+    @classmethod
+    def default_payment_term(cls):
+        PaymentTerm = Pool().get('account.invoice.payment_term')
+        payment_terms = PaymentTerm.search(cls.payment_term.domain)
+        if len(payment_terms) == 1:
+            return payment_terms[0].id
 
-    def __get_account_payment_term(self, type_, party_id, company_id):
+    def __get_account_payment_term(self):
         '''
         Return default account and payment term
         '''
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        company_obj = pool.get('company.company')
-        account_obj = pool.get('account.account')
-        payment_term_obj = pool.get('account.invoice.payment_term')
-
+        account = None
+        payment_term = None
         result = {
             'account': None,
             }
-        if party_id:
-            party = party_obj.browse(party_id)
-            if type_ in ('out_invoice', 'out_credit_note'):
-                result['account'] = party.account_receivable.id
-                if type_ == 'out_invoice' and party.customer_payment_term:
-                    result['payment_term'] = party.customer_payment_term.id
-            elif type_ in ('in_invoice', 'in_credit_note'):
-                result['account'] = party.account_payable.id
-                if type_ == 'in_invoice' and party.supplier_payment_term:
-                    result['payment_term'] = party.supplier_payment_term.id
-        if company_id and type_ in ('out_credit_note', 'in_credit_note'):
-            company = company_obj.browse(company_id)
-            if type_ == 'out_credit_note':
-                result['payment_term'] = company.customer_payment_term.id
+        if self.party:
+            if self.type in ('out_invoice', 'out_credit_note'):
+                account = self.party.account_receivable
+                if (self.type == 'out_invoice'
+                        and self.party.customer_payment_term):
+                    payment_term = self.party.customer_payment_term
+            elif self.type in ('in_invoice', 'in_credit_note'):
+                account = self.party.account_payable
+                if (self.type == 'in_invoice'
+                        and self.party.supplier_payment_term):
+                    payment_term = self.party.supplier_payment_term
+        if self.company and self.type in ('out_credit_note', 'in_credit_note'):
+            if self.type == 'out_credit_note':
+                payment_term = self.company.customer_payment_term
             else:
-                result['payment_term'] = company.supplier_payment_term.id
-        if result['account']:
-            result['account.rec_name'] = account_obj.browse(
-                    result['account']).rec_name
-        if result.get('payment_term'):
-            result['payment_term.rec_name'] = payment_term_obj.browse(
-                    result['payment_term']).rec_name
+                payment_term = self.company.supplier_payment_term
+        if account:
+            result['account'] = account.id
+            result['account.rec_name'] = account.rec_name
+        if payment_term:
+            result['payment_term'] = payment_term.id
+            result['payment_term.rec_name'] = payment_term.rec_name
         return result
 
-    def on_change_type(self, vals):
-        journal_obj = Pool().get('account.journal')
+    def on_change_type(self):
+        Journal = Pool().get('account.journal')
         res = {}
-        journal_ids = journal_obj.search([
-            ('type', '=', _TYPE2JOURNAL.get(vals.get('type', 'out_invoice'),
-                'revenue')),
-            ], limit=1)
-        if journal_ids:
-            journal = journal_obj.browse(journal_ids[0])
+        journals = Journal.search([
+                ('type', '=', _TYPE2JOURNAL.get(self.type or 'out_invoice',
+                        'revenue')),
+                ], limit=1)
+        if journals:
+            journal, = journals
             res['journal'] = journal.id
             res['journal.rec_name'] = journal.rec_name
-        res.update(self.__get_account_payment_term(vals.get('type'),
-                vals.get('party'), vals.get('company')))
+        res.update(self.__get_account_payment_term())
         return res
 
-    def on_change_party(self, vals):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        address_obj = pool.get('party.address')
+    def on_change_party(self):
         res = {
             'invoice_address': None,
-        }
-        res.update(self.__get_account_payment_term(vals.get('type'),
-                vals.get('party'), vals.get('company')))
+            }
+        res.update(self.__get_account_payment_term())
 
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            res['invoice_address'] = party_obj.address_get(party.id,
-                    type='invoice')
-        if res['invoice_address']:
-            res['invoice_address.rec_name'] = address_obj.browse(
-                    res['invoice_address']).rec_name
+        if self.party:
+            invoice_address = self.party.address_get(type='invoice')
+            res['invoice_address'] = invoice_address.id
+            res['invoice_address.rec_name'] = invoice_address.rec_name
         return res
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.currency:
+            return self.currency.digits
         return 2
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for invoice in self.browse(ids):
-            res[invoice.id] = invoice.currency.digits
-        return res
+    def on_change_with_currency_date(self, name=None):
+        Date = Pool().get('ir.date')
+        return self.invoice_date or Date.today()
 
-    def on_change_with_currency_date(self, vals):
-        date_obj = Pool().get('ir.date')
-        today = date_obj.today()
-        date = vals.get('invoice_date') or today
-        return date
-
-    def get_currency_date(self, ids, name):
-        date_obj = Pool().get('ir.date')
-        res = {}
-        today = date_obj.today()
-        for invoice in self.browse(ids):
-            res[invoice.id] = invoice.invoice_date or today
-        return res
-
-    def on_change_with_party_lang(self, vals):
-        party_obj = Pool().get('party.party')
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            if party.lang:
-                return party.lang.code
+    def on_change_with_party_lang(self, name=None):
+        if self.party:
+            if self.party.lang:
+                return self.party.lang.code
         return CONFIG['language']
 
-    def get_party_language(self, ids, name):
-        '''
-        Return the language code of the party of each invoice
-
-        :param ids: the ids of the invoices
-        :param name: the field name
-        :return: a dictionary with invoice id as key and
-            language code as value
-        '''
-        res = {}
-        for invoice in self.browse(ids):
-            if invoice.party.lang:
-                res[invoice.id] = invoice.party.lang.code
-            else:
-                res[invoice.id] = CONFIG['language']
-        return res
-
-    def get_type_name(self, ids, name):
-        res = {}
+    @classmethod
+    def get_type_name(self, invoices, name):
+        type_names = {}
         type2name = {}
         for type, name in self.fields_get(fields_names=['type']
                 )['type']['selection']:
             type2name[type] = name
-        for invoice in self.browse(ids):
-            res[invoice.id] = type2name[invoice.type]
-        return res
+        for invoice in invoices:
+            type_names[invoice.id] = type2name[invoice.type]
+        return type_names
 
-    def on_change_lines(self, vals):
-        return self._on_change_lines_taxes(vals)
+    def on_change_lines(self):
+        return self._on_change_lines_taxes()
 
-    def on_change_taxes(self, vals):
-        return self._on_change_lines_taxes(vals)
+    def on_change_taxes(self):
+        return self._on_change_lines_taxes()
 
-    def _on_change_lines_taxes(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        tax_obj = Pool().get('account.tax')
+    def _on_change_lines_taxes(self):
+        pool = Pool()
+        Tax = pool.get('account.tax')
         res = {
             'untaxed_amount': Decimal('0.0'),
             'tax_amount': Decimal('0.0'),
             'total_amount': Decimal('0.0'),
             'taxes': {},
-        }
-        currency = None
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
+            }
         computed_taxes = {}
-        if vals.get('lines'):
-            context = self.get_tax_context(vals)
-            for line in vals['lines']:
-                if line.get('type', 'line') != 'line':
+        if self.lines:
+            context = self.get_tax_context()
+            for line in self.lines:
+                if (line.type or 'line') != 'line':
                     continue
-                res['untaxed_amount'] += line.get('amount') or 0
+                res['untaxed_amount'] += line.amount or 0
                 with Transaction().set_context(**context):
-                    taxes = tax_obj.compute(line.get('taxes', []),
-                            line.get('unit_price') or Decimal('0.0'),
-                            line.get('quantity', 0.0))
+                    taxes = Tax.compute(line.taxes,
+                        line.unit_price or Decimal('0.0'),
+                        line.quantity or 0.0)
                 for tax in taxes:
                     key, val = self._compute_tax(tax,
-                            vals.get('type', 'out_invoice'))
+                        self.type or 'out_invoice')
                     if not key in computed_taxes:
                         computed_taxes[key] = val
                     else:
                         computed_taxes[key]['base'] += val['base']
                         computed_taxes[key]['amount'] += val['amount']
-        if currency:
+        if self.currency:
             for key in computed_taxes:
                 for field in ('base', 'amount'):
-                    computed_taxes[key][field] = currency_obj.round(currency,
-                            computed_taxes[key][field])
+                    computed_taxes[key][field] = self.currency.round(
+                        computed_taxes[key][field])
         tax_keys = []
-        for tax in vals.get('taxes', []):
-            if tax.get('manual', False):
-                res['tax_amount'] += tax.get('amount') or Decimal('0.0')
+        for tax in (self.taxes or []):
+            if tax.manual:
+                res['tax_amount'] += tax.amount or Decimal('0.0')
                 continue
-            key = (tax.get('base_code'), tax.get('base_sign'),
-                    tax.get('tax_code'), tax.get('tax_sign'),
-                    tax.get('account'), tax.get('tax'))
+            key = (tax.base_code, tax.base_sign,
+                tax.tax_code, tax.tax_sign,
+                tax.account, tax.tax)
             if (key not in computed_taxes) or (key in tax_keys):
                 res['taxes'].setdefault('remove', [])
-                res['taxes']['remove'].append(tax.get('id'))
+                res['taxes']['remove'].append(tax.id)
                 continue
             tax_keys.append(key)
-            if currency:
-                if not currency_obj.is_zero(currency,
+            if self.currency:
+                if not self.currency.is_zero(
                         computed_taxes[key]['base'] - \
-                                (tax.get('base') or Decimal('0.0'))):
+                            (tax.base or Decimal('0.0'))):
                     res['tax_amount'] += computed_taxes[key]['amount']
                     res['taxes'].setdefault('update', [])
                     res['taxes']['update'].append({
-                        'id': tax.get('id'),
+                            'id': tax.id,
+                            'amount': computed_taxes[key]['amount'],
+                            'base': computed_taxes[key]['base'],
+                            })
+                else:
+                    res['tax_amount'] += tax.amount or Decimal('0.0')
+            else:
+                if (computed_taxes[key]['base'] - (tax.base or Decimal('0.0'))
+                        != Decimal('0.0')):
+                    res['tax_amount'] += computed_taxes[key]['amount']
+                    res['taxes'].setdefault('update', [])
+                    res['taxes']['update'].append({
+                        'id': tax.id,
                         'amount': computed_taxes[key]['amount'],
                         'base': computed_taxes[key]['base'],
                         })
                 else:
-                    res['tax_amount'] += tax.get('amount') or Decimal('0.0')
-            else:
-                if computed_taxes[key]['base'] - \
-                        (tax.get('base') or Decimal('0.0')) != Decimal('0.0'):
-                    res['tax_amount'] += computed_taxes[key]['amount']
-                    res['taxes'].setdefault('update', [])
-                    res['taxes']['update'].append({
-                        'id': tax.get('id'),
-                        'amount': computed_taxes[key]['amount'],
-                        'base': computed_taxes[key]['base'],
-                        })
-                else:
-                    res['tax_amount'] += tax.get('amount') or Decimal('0.0')
+                    res['tax_amount'] += tax.amount or Decimal('0.0')
         for key in computed_taxes:
             if key not in tax_keys:
                 res['tax_amount'] += computed_taxes[key]['amount']
                 res['taxes'].setdefault('add', [])
-                value = tax_obj.default_get(tax_obj._columns.keys())
+                value = Tax.default_get(Tax._fields.keys())
                 value.update(computed_taxes[key])
                 res['taxes']['add'].append(value)
-        if currency:
-            res['untaxed_amount'] = currency_obj.round(currency,
-                    res['untaxed_amount'])
-            res['tax_amount'] = currency_obj.round(currency, res['tax_amount'])
+        if self.currency:
+            res['untaxed_amount'] = self.currency.round(res['untaxed_amount'])
+            res['tax_amount'] = self.currency.round(res['tax_amount'])
         res['total_amount'] = res['untaxed_amount'] + res['tax_amount']
-        if currency:
-            res['total_amount'] = currency_obj.round(currency,
-                    res['total_amount'])
+        if self.currency:
+            res['total_amount'] = self.currency.round(res['total_amount'])
         return res
 
-    def get_untaxed_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        res = {}
-        for invoice in self.browse(ids):
-            res.setdefault(invoice.id, _ZERO)
-            for line in invoice.lines:
-                if line.type != 'line':
-                    continue
-                res[invoice.id] += line.amount
-            res[invoice.id] = currency_obj.round(invoice.currency,
-                    res[invoice.id])
-        return res
+    def get_untaxed_amount(self, name):
+        amount = _ZERO
+        for line in self.lines:
+            if line.type != 'line':
+                continue
+            amount += line.amount
+        return self.currency.round(amount)
 
-    def get_tax_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
+    @classmethod
+    def get_tax_amount(cls, invoices, name):
         cursor = Transaction().cursor
         res = {}
-        type_name = FIELDS[self.tax_amount._type].sql_type(self.tax_amount)[0]
-        red_sql, red_ids = reduce_ids('invoice', ids)
+        type_name = FIELDS[cls.tax_amount._type].sql_type(cls.tax_amount)[0]
+        red_sql, red_ids = reduce_ids('invoice', [i.id for i in invoices])
         cursor.execute('SELECT invoice, ' \
                     'CAST(COALESCE(SUM(amount), 0) AS ' + type_name + ') ' \
                 'FROM account_invoice_tax ' \
@@ -533,66 +489,56 @@
                 sum = Decimal(str(sum))
             res[invoice_id] = sum
 
-        for invoice in self.browse(ids):
+        for invoice in invoices:
             res.setdefault(invoice.id, Decimal('0.0'))
-            res[invoice.id] = currency_obj.round(invoice.currency,
-                    res[invoice.id])
+            res[invoice.id] = invoice.currency.round(res[invoice.id])
         return res
 
-    def get_total_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        res = {}
-        for invoice in self.browse(ids):
-            res[invoice.id] = currency_obj.round(invoice.currency,
-                    invoice.untaxed_amount + invoice.tax_amount)
-        return res
+    def get_total_amount(self, name):
+        return self.currency.round(self.untaxed_amount + self.tax_amount)
 
-    def get_reconciled(self, ids, name):
-        res = {}
-        for invoice in self.browse(ids):
-            res[invoice.id] = True
-            if not invoice.lines_to_pay:
-                res[invoice.id] = False
-                continue
-            for line in invoice.lines_to_pay:
-                if not line.reconciliation:
-                    res[invoice.id] = False
-                    break
-        return res
+    def get_reconciled(self, name):
+        if not self.lines_to_pay:
+            return False
+        for line in self.lines_to_pay:
+            if not line.reconciliation:
+                return False
+        return True
 
-    def get_lines_to_pay(self, ids, name):
-        res = {}
-        for invoice in self.browse(ids):
-            lines = []
-            if invoice.move:
-                for line in invoice.move.lines:
-                    if line.account.id == invoice.account.id \
-                            and line.maturity_date:
-                        lines.append(line)
-            lines.sort(key=operator.attrgetter('maturity_date'))
-            res[invoice.id] = [x.id for x in lines]
-        return res
+    def get_lines_to_pay(self, name):
+        lines = []
+        if self.move:
+            for line in self.move.lines:
+                if (line.account.id == self.account.id
+                        and line.maturity_date):
+                    lines.append(line)
+        lines.sort(key=operator.attrgetter('maturity_date'))
+        return [x.id for x in lines]
 
-    def get_amount_to_pay(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        date_obj = Pool().get('ir.date')
+    @classmethod
+    def get_amount_to_pay(cls, invoices, name):
+        pool = Pool()
+        Currency = pool.get('currency.currency')
+        Date = pool.get('ir.date')
 
-        compute_ids = self.search([
-            ('id', 'in', ids),
-            ('state', '=', 'open'),
-            ])
+        computes = cls.search([
+                ('id', 'in', [i.id for i in invoices]),
+                ('state', '=', 'open'),
+                ])
 
-        res = dict((x, _ZERO) for x in ids)
-        for invoice in self.browse(compute_ids):
+        today = Date.today()
+        res = dict((x.id, _ZERO) for x in invoices)
+        for invoice in computes:
             amount = _ZERO
             amount_currency = _ZERO
             for line in invoice.lines_to_pay:
                 if line.reconciliation:
                     continue
-                if name == 'amount_to_pay_today' \
-                        and line.maturity_date > date_obj.today():
+                if (name == 'amount_to_pay_today'
+                        and line.maturity_date > today):
                     continue
-                if line.second_currency.id == invoice.currency.id:
+                if (line.second_currency
+                        and line.second_currency == invoice.currency):
                     if line.debit - line.credit > _ZERO:
                         amount_currency += abs(line.amount_second_currency)
                     else:
@@ -602,7 +548,8 @@
             for line in invoice.payment_lines:
                 if line.reconciliation:
                     continue
-                if line.second_currency.id == invoice.currency.id:
+                if (line.second_currency
+                        and line.second_currency == invoice.currency):
                     if line.debit - line.credit > _ZERO:
                         amount_currency += abs(line.amount_second_currency)
                     else:
@@ -614,40 +561,41 @@
                 amount_currency = - amount_currency
             if amount != _ZERO:
                 with Transaction().set_context(date=invoice.currency_date):
-                    amount_currency += currency_obj.compute(
-                    invoice.company.currency.id, amount, invoice.currency.id)
+                    amount_currency += Currency.compute(
+                        invoice.company.currency, amount, invoice.currency)
             if amount_currency < _ZERO:
                 amount_currency = _ZERO
             res[invoice.id] = amount_currency
         return res
 
-    def search_total_amount(self, name, clause):
+    @classmethod
+    def search_total_amount(cls, name, clause):
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
-        line_obj = pool.get('account.invoice.line')
-        tax_obj = pool.get('account.invoice.tax')
-        type_name = FIELDS[self.total_amount._type].sql_type(
-                self.total_amount)[0]
+        Rule = pool.get('ir.rule')
+        Line = pool.get('account.invoice.line')
+        Tax = pool.get('account.invoice.tax')
+        type_name = FIELDS[cls.total_amount._type].sql_type(
+            cls.total_amount)[0]
         cursor = Transaction().cursor
 
-        invoice_query, invoice_val = rule_obj.domain_get('account.invoice')
+        invoice_query, invoice_val = Rule.domain_get('account.invoice')
 
         cursor.execute('SELECT invoice FROM ('
                     'SELECT invoice, '
                         'COALESCE(SUM(quantity * unit_price), 0) '
                             'AS total_amount '
-                    'FROM "' + line_obj._table + '" '
-                    'JOIN "' + self._table + '" ON '
-                        '("' + self._table + '".id = '
-                            '"' + line_obj._table + '".invoice) '
+                    'FROM "' + Line._table + '" '
+                    'JOIN "' + cls._table + '" ON '
+                        '("' + cls._table + '".id = '
+                            '"' + Line._table + '".invoice) '
                     'WHERE ' + invoice_query + ' '
                     'GROUP BY invoice '
                 'UNION '
                     'SELECT invoice, COALESCE(SUM(amount), 0) AS total_amount '
-                    'FROM "' + tax_obj._table + '" '
-                    'JOIN "' + self._table + '" ON '
-                        '("' + self._table + '".id = '
-                            '"' + tax_obj._table + '".invoice) '
+                    'FROM "' + Tax._table + '" '
+                    'JOIN "' + cls._table + '" ON '
+                        '("' + cls._table + '".id = '
+                            '"' + Tax._table + '".invoice) '
                     'WHERE ' + invoice_query + ' '
                     'GROUP BY invoice  '
                 ') AS u '
